import pandas as pd
from datareaders import *
import scipy as sp
from sklearn.feature_extraction.text import TfidfVectorizer
from mymodel import *
from sklearn.feature_selection import SelectKBest, chi2
import nltk

#dataTRAC = TRACAggressionReader("./datasets/AggressionFB")
#dataGO = GaoReader("./datasets/GaoEtAl")
dataKAGGLE = KaggleToxicJigsawReader("./datasets/KaggleToxicJigsaw")
#dataKOL = KolhatkarReader("./datasets/Kolhatkar")
#dataWas1 = WaseemNAACLReader("./datasets/WaseemHovyNAACL")
#dataWas2 = WaseemNLPReader("./datasets/WaseemNLPaCSS")
dataWul1 = WulczynReader("./datasets/WulczynAggression/4267550/aggression_annotated_comments.tsv", "./datasets/WulczynAggression/4267550/aggression_annotations.tsv", "aggression")
dataWul2 = WulczynReader("./datasets/WulczynPersAttack/4054689/attack_annotated_comments.tsv", "./datasets/WulczynPersAttack/4054689/attack_annotations.tsv", "attack")
dataWul3 = WulczynReader("./datasets/WulczynToxicity/4563973/toxicity_annotated_comments.tsv", "./datasets/WulczynToxicity/4563973/toxicity_annotations.tsv", "toxicity")


datasets_list = [(dataWul1, "Wul1"), (dataWul2, "Wul2"), (dataWul3, "Wul3"), (dataKAGGLE, "KAGGLE")]
#datasets_list = [(dataWul1, "Wul1"), (dataKAGGLE, "KAGGLE")]



for data, data_ID in datasets_list:
        for data2, data2_ID in datasets_list:
                if data_ID == data2_ID:
                        continue
        
                print(data_ID + " vs " + data2_ID)
        
                data_texts = pd.concat([data.train_texts, data.dev_texts])
                data2_texts = pd.concat([ data2.test_texts])
 
                #data_texts = pd.concat([data.train_texts, data.dev_texts, data.test_texts])
                #data2_texts = pd.concat([data2.train_texts, data2.dev_texts, data2.test_texts])
                
                print("Calculating intersection ...")
                intersection = set([t.lower() for t in set(data_texts)]) & set([t.lower() for t in set(data2_texts)])
                print(len(data_texts))
                print(len(data2_texts))
                print(len(intersection))
                print()
                print()
                print()
                print()
        
